//+------------------------------------------------------------------------
//
//  Copyright @ Baris TAZE
//
//  File:     GASettings.h
//
//  Content:  Interface for CGASettings class
//  
//  Classes:  CGASettings
//            
//  History:  27-May-2002    created by baris taze .  
//
//-------------------------------------------------------------------------

#pragma once

#include "DefinitionsGA.h"

class CGASettings
{
public:
	CGASettings();
	~CGASettings();
	
	bool operator == ( CGASettings& arSettings );

	double GetCrossOverRate();
	void SetCrossOverRate( double afCrossOverRate);

	double GetMutationRate();
	void SetMutationRate( double afMutationRate );

	long GetPopSize();
	void SetPopSize( long anPopSize );

	long GetCrossOverType();
	void SetCrossOverType( long anCrossOverType );

	double GetCrsOvrUnfChance();
	void SetCrsOvrUnfChance( double afCrsOvrUnfChance );

	long GetNatSelType();
	void SetNatSelType( long anNatSelType );

	long GetNatSelGntr();
	void SetNatSelGntr( long anNatSelGntr );

	double GetNatSelTrnmt();
	void SetNatSelTrnmt( double afNatSelTrnmt );



	long GetAStopCriteriaType();
	void SetAStopCriteriaType( long anAStopCriteriaType );

	double GetAStopCriteriaBias();
	void SetAStopCriteriaBias( double afAStopCriteriaBias );

	long GetAStopCriteriaMinute();
	void SetAStopCriteriaMinute( long anAStopCriteriaMinute );

	long GetAStopCriteriaIteration();
	void SetAStopCriteriaIteration( long anAStopCriteriaIteration );

	long GetAStopCriteriaRefinement();
	void SetAStopCriteriaRefinement( long anAStopCriteriaRefinement );
	
	bool IsAnyAutoStopAssigned();
	void SetAllAutosByDefaultsValues();
	
protected:
	double m_fCrossOverRate;
	double m_fMutationRate;
	long   m_nPopSize;

	long   m_nCrossOverType;
	double m_fCrsOvrUnfChance;

	long   m_nNatSelType;
	long   m_nNatSelGntr; 
	double m_fNatSelTrnmt;

	long	m_nAStopCriteriaType;
	double	m_fAStopCriteriaBias;
	long	m_nAStopCriteriaMinute;
	long	m_nAStopCriteriaIteration;
	long	m_nAStopCriteriaRefinement;
};
